#pragma once

#include "Betriebssystem.h"

namespace Framework
{
    class ReferenceCounter
    {
    private:
        int ref;

    public:
        DLLEXPORT ReferenceCounter();
        DLLEXPORT virtual ~ReferenceCounter();

        DLLEXPORT ReferenceCounter *getThis();
        DLLEXPORT ReferenceCounter *release();

        template<typename T>
        inline T *as() const
        {
            return dynamic_cast<T>( this )
        }
    };
}